//
//  AppDelegate.m
//  ifreeSampleObjC_13
//
//  Created by HeeJun Shin on 2022/07/05.
//

#import "AppDelegate.h"

#import "ViewController.h"
#import "NavigationController.h"

//1. ifree setting
#import <ifreeauth/ifreeauth.h>
#import <ifreeauth/ifreeWebViewController.h>

#import "LoginViewController.h"

@interface AppDelegate ()

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
  
    
    if(@available(iOS 13.0, *))
    {
        return YES;
    }
    else
    {
        self.storyboard = [UIStoryboard storyboardWithName:@"Main" bundle:nil];
        ViewController *mainController = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewController"];
        self.navigationController = [[NavigationController alloc] initWithRootViewController:mainController];
        self.window.rootViewController = self.navigationController;

        [self.window makeKeyAndVisible];
        
        //2. ifree setting

        NSString *clientID = [[ifreeManager getInstance] getClientId];
        [[ifreeManager getInstance] setAppScheme:[NSString stringWithFormat:@"pk%@", clientID]];
      
        return YES;
    }
    

    
}


- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<UIApplicationOpenURLOptionsKey,id> *)options
{
    NSLog(@"application openURL=======");
    
    //3. passikey setting
    if ([url.scheme isEqualToString: [[ifreeManager getInstance] getAppScheme]]) {
        
        NSObject *objRootViewcontroller = self.window.rootViewController;
        
        if ([objRootViewcontroller isKindOfClass:UINavigationController.class])
        {
            UINavigationController *navigationController = (UINavigationController *)objRootViewcontroller;
            //최상위 화면 체크
            id vcCheck = navigationController.topViewController;
            
            id vc;
            
            if(vcCheck == nil || ![vcCheck isKindOfClass:[ifreeWebViewController class]])
            {

                UIViewController *presentController =  navigationController.presentedViewController;
                if ([presentController isKindOfClass:[LoginViewController class]])
                {
                    vc =  presentController.presentedViewController;
                    if ([vc isKindOfClass:[ifreeWebViewController class]])
                    {
                        NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                        if(strParsingDic != nil)
                        {
                            [vc resultProcess:strParsingDic];
                        }
                    }
                }
                else
                {
                    
                   if([presentController isKindOfClass:[ifreeWebViewController class]])
                   {
                       vc =  presentController;
                       NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                       if(strParsingDic != nil)
                       {
                           [vc resultProcess:strParsingDic];
                       }
                   }
                }
                
            }
            else
            {
                id vc = navigationController.topViewController;
                
                if ([vc isKindOfClass:[ifreeWebViewController class]])
                {
                    NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                    if(strParsingDic != nil)
                    {
                        [vc resultProcess:strParsingDic];
                    }
                }
                else
                {
                    //화면이 종료됨.
                }
            }
        }
        else
        {
            if ([objRootViewcontroller isKindOfClass:UIViewController.class])
            {
                id vcCheck = objRootViewcontroller;
                
                if( [vcCheck isKindOfClass:[ifreeWebViewController class]])
                {
                    NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                    if(strParsingDic != nil)
                    {
                        [vcCheck resultProcess:strParsingDic];
                    }
                }
                else
                {
                    UIViewController *lastViewController = (UIViewController *)vcCheck;
                    UIViewController *presentController = lastViewController.presentedViewController;
                    if ([presentController isKindOfClass:[LoginViewController class]])
                    {
                        id vc =  presentController.presentedViewController;
                        if ([vc isKindOfClass:[ifreeWebViewController class]])
                        {
                            NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                            if(strParsingDic != nil)
                            {
                                [vc resultProcess:strParsingDic];
                            }
                        }
                    }
                    else
                    {
                        
                       if([presentController isKindOfClass:[ifreeWebViewController class]])
                       {
                           id vc =  presentController;
                           NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                           if(strParsingDic != nil)
                           {
                               [vc resultProcess:strParsingDic];
                           }
                       }
                    }
       
                }
            }
        }
    }
        
        
    
    return YES;
}


#pragma mark - UISceneSession lifecycle


- (UISceneConfiguration *)application:(UIApplication *)application configurationForConnectingSceneSession:(UISceneSession *)connectingSceneSession options:(UISceneConnectionOptions *)options {
    // Called when a new scene session is being created.
    // Use this method to select a configuration to create the new scene with.
    return [[UISceneConfiguration alloc] initWithName:@"Default Configuration" sessionRole:connectingSceneSession.role];
}


- (void)application:(UIApplication *)application didDiscardSceneSessions:(NSSet<UISceneSession *> *)sceneSessions {
    // Called when the user discards a scene session.
    // If any sessions were discarded while the application was not running, this will be called shortly after application:didFinishLaunchingWithOptions.
    // Use this method to release any resources that were specific to the discarded scenes, as they will not return.
}


@end
