//
//  LoginViewController.m
//  ifreeSampleObjC
//
//  Created by HeeJun Shin on 2022/06/30.
//  Copyright © 2022 ROWEM. All rights reserved.
//

#import "LoginViewController.h"

@interface LoginViewController ()

@end

@implementation LoginViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/


#pragma mark - IBAction
- (IBAction) actionConnectWithifree:(id)sender
{
    
    //파트너사가 생성한 token
    NSString *partnerStateToken = @"12345";
    [[ifreeManager getInstance] loginStylePresentView:self withStateToken:partnerStateToken];
}

- (IBAction) actionSuccess:(id)sender
{
    [self dismissViewControllerAnimated:NO completion:nil];
}


- (void) actionPartnerLoginWithifreeAuth
{
    // 화면 처리
    //TODO:

    NSLog(@"actionPartnerLoginWithifreeAuth");
    if( [[ifreeManager getInstance] getReciveStateToken] == nil)
    {
        [self showMessage:@"getReciveStateToken empty"];
        return;
    }
    
    if(![[[ifreeManager getInstance] getStateToken] isEqualToString: [[ifreeManager getInstance] getReciveStateToken]])
    {
        [self showMessage:@"getStateToken not same"];
        return;
    }
    
    if( [[ifreeManager getInstance] getPartnerToken] == nil)
    {
        [self showMessage:@"getPartnerToken empty"];
        return;
    }
    
    NSMutableDictionary *loginDic = [NSMutableDictionary dictionary];
    [loginDic setValue: [[ifreeManager getInstance] getClientId] forKey:@"client_id"];
    [loginDic setValue: [[ifreeManager getInstance] getPartnerToken] forKey:@"ptn_token"];
    // 각 제휴사 마다 다름
    [[ifreeManager getInstance] partnerLoginCheck:loginDic withCompletion:^(NSDictionary* result, NSError * _Nonnull error) {
        [[ifreeManager getInstance] closeAuthResult];
        
        if( [[result objectForKey:@"code"] isEqualToString:@"0000"] )
        {
            [self showMessage:@"파트너사 로그인 성공 "];
        }
        else
        {
            [self showMessage:[NSString stringWithFormat: @"파트너사 로그인 에러 처리 ( %@ )",[result objectForKey:@"code"]]];
        }
    }];
}

#pragma mark - PassikeyWebViewControllerDelegate

- (void)onCallback:(NSMutableDictionary *)successAuthValue withErrInfo: (NSMutableDictionary *)errInfo
{
    NSLog(@"ViewCongtroller onCallback %@ ",successAuthValue);
    NSLog(@"ViewCongtroller onCallback  errInfo%@ ",errInfo);
    // result_code: sdk내부 정의 값
    // err_code: 패시키 앱에서 내려주는 코드(에러)
//    
    if(successAuthValue != nil)
    {
        [self.delegate loginInfo:[NSString stringWithFormat:@"ResultValue:%@\nptn_token:%@\nstat_token:%@",[successAuthValue objectForKey:@"result_code"],[successAuthValue objectForKey:@"ptn_token"],[successAuthValue objectForKey:@"stat_token"]]];
//        self.tvInfoView.text = [NSString stringWithFormat:@"ResultValue:%@\nptn_token:%@\nstat_token:%@",[successAuthValue objectForKey:@"result_code"],[successAuthValue objectForKey:@"ptn_token"],[successAuthValue objectForKey:@"stat_token"]];
        [self actionPartnerLoginWithifreeAuth];
    }
//    else
//    {
//        
        if ([errInfo objectForKey:@"result_code"] != nil)
        {
            NSString *message;
            if([errInfo objectForKey:@"err_code"] != nil)
            {
                message = [NSString stringWithFormat:@"ResultValue: %@(%@)",[errInfo objectForKey:@"result_code"],[errInfo objectForKey:@"err_code"]];
            }
            else
            {
                message = [NSString stringWithFormat:@"ResultValue: %@",[errInfo objectForKey:@"result_code"]];
            }
            [self.delegate loginInfo: message];
           
        }
        else if ([errInfo objectForKey:@"result_code"] == nil &&  [errInfo objectForKey:@"err_code"] != nil)
        {
            NSString *message = [NSString stringWithFormat:@"ResultValue: %@",[errInfo objectForKey:@"err_code"]];
            [self.delegate loginInfo: message];
        }
        else if ([errInfo objectForKey:@"code"] != nil)
        {
            NSString *message = [NSString stringWithFormat:@"ResultValue: %@",[errInfo objectForKey:@"code"]];
            [self.delegate loginInfo: message];
        }
//    }
    
    
}

#pragma mark -
- (void) showMessage:(NSString *)message
{
    UIAlertController * alertController=   [UIAlertController
                                            alertControllerWithTitle:nil
                                            message:message
                                            preferredStyle:UIAlertControllerStyleAlert];
    
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"확인" style:UIAlertActionStyleDefault handler:nil];
    
    [alertController addAction:okAction];
    
    [self presentViewController:alertController animated:YES completion:nil];
}

@end
