//
//  SceneDelegate.m
//  ifreeSampleObjC_13
//
//  Created by HeeJun Shin on 2022/07/05.
//

#import "SceneDelegate.h"

#import "ViewController.h"
#import "NavigationController.h"

@interface SceneDelegate ()

@end

@implementation SceneDelegate


- (void)scene:(UIScene *)scene willConnectToSession:(UISceneSession *)session options:(UISceneConnectionOptions *)connectionOptions {
    // Use this method to optionally configure and attach the UIWindow `window` to the provided UIWindowScene `scene`.
    // If using a storyboard, the `window` property will automatically be initialized and attached to the scene.
    // This delegate does not imply the connecting scene or session are new (see `application:configurationForConnectingSceneSession` instead).
    
    
    NSString *clientID = [[ifreeManager getInstance] getClientId];
    [[ifreeManager getInstance] setAppScheme:[NSString stringWithFormat:@"pk%@", clientID]];

   
}

- (void)scene:(UIScene *)scene openURLContexts:(nonnull NSSet<UIOpenURLContext *> *)URLContexts
API_AVAILABLE(ios(13.0)){
    NSURL *url = [[URLContexts allObjects] firstObject].URL;

    //3. passikey setting
    if ([url.scheme isEqualToString: [[ifreeManager getInstance] getAppScheme]]) {
        
        NSObject *objRootViewcontroller = self.window.rootViewController;
        
        if ([objRootViewcontroller isKindOfClass:UINavigationController.class])
        {
            UINavigationController *navigationController = (UINavigationController *)objRootViewcontroller;
            //최상위 화면 체크
            id vcCheck = navigationController.topViewController;
            
            id vc;
            
            if(vcCheck == nil || ![vcCheck isKindOfClass:[ifreeWebViewController class]])
            {

                UIViewController *presentController =  navigationController.presentedViewController;
                if ([presentController isKindOfClass:[LoginViewController class]])
                {
                    vc =  presentController.presentedViewController;
                    if ([vc isKindOfClass:[ifreeWebViewController class]])
                    {
                        NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                        if(strParsingDic != nil)
                        {
                            [vc resultProcess:strParsingDic];
                        }
                    }
                }
                else
                {
                    
                   if([presentController isKindOfClass:[ifreeWebViewController class]])
                   {
                       vc =  presentController;
                       NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                       if(strParsingDic != nil)
                       {
                           [vc resultProcess:strParsingDic];
                       }
                   }
                }
                
            }
            else
            {
                id vc = navigationController.topViewController;
                
                if ([vc isKindOfClass:[ifreeWebViewController class]])
                {
                    NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                    if(strParsingDic != nil)
                    {
                        [vc resultProcess:strParsingDic];
                    }
                }
                else
                {
                    //화면이 종료됨.
                }
            }
        }
        else
        {
            if ([objRootViewcontroller isKindOfClass:UIViewController.class])
            {
                id vcCheck = objRootViewcontroller;
                
                if( [vcCheck isKindOfClass:[ifreeWebViewController class]])
                {
                    NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                    if(strParsingDic != nil)
                    {
                        [vcCheck resultProcess:strParsingDic];
                    }
                }
                else
                {
                    UIViewController *lastViewController = (UIViewController *)vcCheck;
                    UIViewController *presentController = lastViewController.presentedViewController;
                    if ([presentController isKindOfClass:[LoginViewController class]])
                    {
                        id vc =  presentController.presentedViewController;
                        if ([vc isKindOfClass:[ifreeWebViewController class]])
                        {
                            NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                            if(strParsingDic != nil)
                            {
                                [vc resultProcess:strParsingDic];
                            }
                        }
                    }
                    else
                    {
                        
                       if([presentController isKindOfClass:[ifreeWebViewController class]])
                       {
                           id vc =  presentController;
                           NSDictionary *strParsingDic = [[ifreeManager getInstance] ifreeResultParsing:url];
                           if(strParsingDic != nil)
                           {
                               [vc resultProcess:strParsingDic];
                           }
                       }
                    }
       
                }
            }
        }
    }
}


- (void)sceneDidDisconnect:(UIScene *)scene {
    // Called as the scene is being released by the system.
    // This occurs shortly after the scene enters the background, or when its session is discarded.
    // Release any resources associated with this scene that can be re-created the next time the scene connects.
    // The scene may re-connect later, as its session was not necessarily discarded (see `application:didDiscardSceneSessions` instead).
}


- (void)sceneDidBecomeActive:(UIScene *)scene {
    // Called when the scene has moved from an inactive state to an active state.
    // Use this method to restart any tasks that were paused (or not yet started) when the scene was inactive.
}


- (void)sceneWillResignActive:(UIScene *)scene {
    // Called when the scene will move from an active state to an inactive state.
    // This may occur due to temporary interruptions (ex. an incoming phone call).
}


- (void)sceneWillEnterForeground:(UIScene *)scene {
    // Called as the scene transitions from the background to the foreground.
    // Use this method to undo the changes made on entering the background.
}


- (void)sceneDidEnterBackground:(UIScene *)scene {
    // Called as the scene transitions from the foreground to the background.
    // Use this method to save data, release shared resources, and store enough scene-specific state information
    // to restore the scene back to its current state.
}


@end
