//
//  AppDelegate.swift
//  ifreeSampleSWIFT_13
//
//  Created by HeeJun Shin on 2022/07/05.
//

import UIKit

@main
class AppDelegate: UIResponder, UIApplicationDelegate {
    var window: UIWindow?


    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        // Override point for customization after application launch.
        guard #available(iOS 13, *) else {
            let mainStoryboard = UIStoryboard(name: "Main", bundle: nil)
            
            // rootViewController
            let rootViewController = mainStoryboard.instantiateViewController(withIdentifier: "ViewController") as? UIViewController
            
            // navigationController
            let navigationController = UINavigationController(rootViewController: rootViewController!)
            
            navigationController.isNavigationBarHidden = true // or not, your choice.
            
            // self.window
            self.window = UIWindow(frame: UIScreen.main.bounds)
            
            self.window!.rootViewController = navigationController
            
            self.window!.makeKeyAndVisible()

            let clientId:String = ifreeManager.getInstance().getClientId()
            let mergeClientId:String = "pk" + clientId
            print("\(mergeClientId)")
            ifreeManager.getInstance().setAppScheme(mergeClientId)
     
            return true
        }
        
        return true
    }
    
    func application(_ application: UIApplication, open url: URL, options: [UIApplication.OpenURLOptionsKey : Any] = [:]) -> Bool {
        print("application open url = \(url)")
        
        let urlString = url.scheme
        if url.scheme ==  ifreeManager.getInstance().getAppScheme()
        {
            
            /*
             ifree앱에서 수행 후 제휴사 앱이 실행 되는 코드
             체크사항:
             ifreeWebviewController가 최상위에 있는지 체크가 필요함
             해당 코드는 없어도 무방함.
             */
            
            let navigationController:UINavigationController? = UIApplication.shared.keyWindow?.rootViewController as? UINavigationController
            //최상위 화면 체크
                        
            if(navigationController == nil)
            {
                print("navigationController == nil")
                let viewController:UIViewController? = self.window?.rootViewController as? UIViewController
                guard let viewControllerCheck = viewController else {return true}

                let ifreeCheck:Bool? = viewControllerCheck.isKind(of: ifreeWebViewController.self)
                if( !ifreeCheck! )
                {
                    let presentController = viewControllerCheck.presentedViewController
                  
                    let loginViewCheck:Bool? = presentController?.isKind(of: LoginViewController.self)
                    if loginViewCheck!
                    {
                        let vc = presentController?.presentedViewController

                        guard let ifreeWebViewController = vc as? ifreeWebViewController else { return true }
                        let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                        if strParsingDic != nil
                        {
                            ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                        }
                    }
                    else
                    {
                        let ifreeViewCheck:Bool? = presentController?.isKind(of: ifreeWebViewController.self)
                        if ifreeViewCheck!
                        {
                            guard let ifreeWebViewController = presentController as? ifreeWebViewController else { return true }
                            let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                            if strParsingDic != nil
                            {
                                ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                            }
                        }
                    }
                    
                }
                else
                {
                    guard let ifreeWebViewController = viewControllerCheck as? ifreeWebViewController else { return true }
                    let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                    if strParsingDic != nil
                    {
                        ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                    }
                    
                    
                }
            }
            else
            {
                let vcCheck = navigationController?.topViewController
                let ifreeCheck:Bool? = vcCheck?.isKind(of: ifreeWebViewController.self)
                if(vcCheck == nil || !ifreeCheck! )
                {

                    let presentController = navigationController?.presentedViewController

                    let loginViewCheck:Bool? = presentController?.isKind(of: LoginViewController.self)
                    if loginViewCheck!
                    {
                        let vc = presentController?.presentedViewController
   
                        guard let ifreeWebViewController = vc as? ifreeWebViewController else { return true }
                        let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                        if strParsingDic != nil
                        {
                            ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                        }
                    }
                    else
                    {
                        let ifreeViewCheck:Bool? = presentController?.isKind(of: ifreeWebViewController.self)
                        if ifreeViewCheck!
                        {
                            guard let ifreeWebViewController = presentController as? ifreeWebViewController else { return true }
                            let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                            if strParsingDic != nil
                            {
                                ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                            }
                        }
                    }
                    
                }
                else
                {
                    guard let ifreeWebViewController = vcCheck as? ifreeWebViewController else { return true }
                    let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                    if strParsingDic != nil
                    {
                        ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                    }

                }
                
            }
            
        }
        
        return true
    }

    // MARK: UISceneSession Lifecycle
    @available(iOS 13, *)
    func application(_ application: UIApplication, configurationForConnecting connectingSceneSession: UISceneSession, options: UIScene.ConnectionOptions) -> UISceneConfiguration {
        // Called when a new scene session is being created.
        // Use this method to select a configuration to create the new scene with.
        return UISceneConfiguration(name: "Default Configuration", sessionRole: connectingSceneSession.role)
    }
    @available(iOS 13, *)
    func application(_ application: UIApplication, didDiscardSceneSessions sceneSessions: Set<UISceneSession>) {
        // Called when the user discards a scene session.
        // If any sessions were discarded while the application was not running, this will be called shortly after application:didFinishLaunchingWithOptions.
        // Use this method to release any resources that were specific to the discarded scenes, as they will not return.
    }


}

