//
//  LoginViewController.swift
//  ifreeSampleSWIFT
//
//  Created by HeeJun Shin on 2022/07/01.
//  Copyright © 2022 heejun. All rights reserved.
//

import UIKit

extension LoginViewController:ifreeWebViewControllerDelegate
{
    func onCallback(_ successAuthValue: NSMutableDictionary?, withErrInfo errInfo: NSMutableDictionary) {
        if successAuthValue != nil
           {
            var message:String!;
            message = "ResultValue:\(successAuthValue!.object(forKey:"result_code") ?? "") \nptn_token:\(successAuthValue!.object(forKey:"ptn_token") ?? "") \nstat_token:\(successAuthValue!.object(forKey:"stat_token") ?? "")"
            self.delegate?.loginInfo(strInfo: message)
            actionPartnerLoginWithifreeAuth()
           }
           else
           {
               
            if errInfo.object(forKey:"result_code") != nil
            {
                var message:String!;
                if errInfo.object(forKey:"err_code") != nil
                {
                    message = "ResultValue:\(errInfo.object(forKey:"result_code") ?? "") (\(errInfo.object(forKey:"err_code") ?? ""))"
                }
                else
                {
                    message = "ResultValue:\(errInfo.object(forKey:"result_code") ?? "")"
                }
                self.delegate?.loginInfo(strInfo: message)
                
            }
               else if errInfo.object(forKey:"result_code") == nil &&  errInfo.object(forKey:"err_code") != nil
               {
                    var message:String!;
                    message = "ResultValue:\(errInfo.object(forKey:"err_code") ?? "")"
                   self.delegate?.loginInfo(strInfo: message)
               }
               else if errInfo.object(forKey:"code") != nil
               {
                var message:String!;
                message = "ResultValue:\(errInfo.object(forKey:"code") ?? "")"
                   self.delegate?.loginInfo(strInfo: message)
               }
           }
           
    }
}

@objc protocol LoginViewControllerDelegate {
    @objc func loginInfo(strInfo: String)

}
    
class LoginViewController: UIViewController {

    public weak var delegate: LoginViewControllerDelegate?
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }
    

    @IBAction func actionConnectWithifree(_ sender: Any){

        var partnerStateToken = "12345"
        
        ifreeManager.getInstance().loginStylePresentView(self, withStateToken: partnerStateToken) //(parent:self, withStateToken: partnerStateToken)
        
    }
    
    @IBAction func actionSuccess(_ sender: Any){
        self.dismiss(animated: true)
    }
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destination.
        // Pass the selected object to the new view controller.
    }
    */
    func showMessage(message:String)
    {
        let alertController = UIAlertController(title: "", message: message, preferredStyle: .alert)
        let defaultAction = UIAlertAction(title:     NSLocalizedString("Ok", comment: ""), style: .default, handler: { (pAlert) in
                        //Do whatever you want here
                })
        alertController.addAction(defaultAction)
        self.present(alertController, animated: true, completion: nil)
    }
    
    func actionPartnerLoginWithifreeAuth()
    {
        // 화면 처리
        //TODO:

        print("actionPartnerLoginWithifreeAuth")
        let reciveStateToken:String? = ifreeManager.getInstance().getReciveStateToken() as? String
        if( reciveStateToken == nil)
        {
            showMessage(message:"getReciveStateToken empty")
            return;
        }
        
        let stateToken:String? = ifreeManager.getInstance().getStateToken() as? String
        if ( stateToken == nil)
        {
            showMessage(message:"getStateToken empty")
            return;
        }
        

        if reciveStateToken != stateToken
        {
            showMessage(message:"getStateToken not same")
            return;
        }
        
        if ifreeManager.getInstance().getPartnerToken() == nil
        {
            showMessage(message:"getPartnerToken empty")
            return;
        }
        
        let loginDic: NSMutableDictionary? = ["client_id" :  ifreeManager.getInstance().getClientId(),
            "ptn_token" : ifreeManager.getInstance().getPartnerToken() // Always use optional values carefully!
 
        ]
        
        // 각 제휴사 마다 다름
        ifreeManager.getInstance().partnerLoginCheck(loginDic!, withCompletion:{ result, err in
            ifreeManager.getInstance().closeAuthResult()
            
            let codeValue:String = (result["code"] as? String)!
            if codeValue == "0000"
            {
                  self.showMessage(message:"파트너사 로그인 성공 ")
            }
            else
            {
                var message:String!;
                message = "파트너사 로그인 에러 처리 ( \(codeValue)) )"
                self.showMessage(message:message)
            }
            
        })
    }}
