//
//  SceneDelegate.swift
//  ifreeSampleSWIFT_13
//
//  Created by HeeJun Shin on 2022/07/05.
//

import UIKit

class SceneDelegate: UIResponder, UIWindowSceneDelegate {

    var window: UIWindow?

    @available(iOS 13, *)
    func scene(_ scene: UIScene, willConnectTo session: UISceneSession, options connectionOptions: UIScene.ConnectionOptions) {
        // Use this method to optionally configure and attach the UIWindow `window` to the provided UIWindowScene `scene`.
        // If using a storyboard, the `window` property will automatically be initialized and attached to the scene.
        // This delegate does not imply the connecting scene or session are new (see `application:configurationForConnectingSceneSession` instead).
        guard let _ = (scene as? UIWindowScene) else { return }
        
        let clientId:String = ifreeManager.getInstance().getClientId()
        let mergeClientId:String = "pk" + clientId
        print("\(mergeClientId)")
        ifreeManager.getInstance().setAppScheme(mergeClientId)
        
    }
    @available(iOS 13, *)
    func sceneDidDisconnect(_ scene: UIScene) {
        // Called as the scene is being released by the system.
        // This occurs shortly after the scene enters the background, or when its session is discarded.
        // Release any resources associated with this scene that can be re-created the next time the scene connects.
        // The scene may re-connect later, as its session was not necessarily discarded (see `application:didDiscardSceneSessions` instead).
    }
    @available(iOS 13, *)
    func sceneDidBecomeActive(_ scene: UIScene) {
        // Called when the scene has moved from an inactive state to an active state.
        // Use this method to restart any tasks that were paused (or not yet started) when the scene was inactive.
    }
    @available(iOS 13, *)
    func sceneWillResignActive(_ scene: UIScene) {
        // Called when the scene will move from an active state to an inactive state.
        // This may occur due to temporary interruptions (ex. an incoming phone call).
    }
    @available(iOS 13, *)
    func sceneWillEnterForeground(_ scene: UIScene) {
        // Called as the scene transitions from the background to the foreground.
        // Use this method to undo the changes made on entering the background.
    }
    @available(iOS 13, *)
    func sceneDidEnterBackground(_ scene: UIScene) {
        // Called as the scene transitions from the foreground to the background.
        // Use this method to save data, release shared resources, and store enough scene-specific state information
        // to restore the scene back to its current state.
    }

    @available(iOS 13, *)
    func scene(_ scene: UIScene, openURLContexts URLContexts: Set<UIOpenURLContext>) {
          guard let url = URLContexts.first?.url else { return }

        /*
         ifree앱에서 수행 후 제휴사 앱이 실행 되는 코드
         체크사항:
         ifreeWebviewController가 최상위에 있는지 체크가 필요함
         해당 코드는 없어도 무방함.
         */
        print(url)
        if url.scheme ==  ifreeManager.getInstance().getAppScheme()
        {
            //개발자가 최상단 뷰를 찾아 처리해 줘야한다.
            let window = UIApplication.shared.windows.first
            let navigationController:UINavigationController? = window?.rootViewController as? UINavigationController
                        
            if(navigationController == nil)
            {
                print("navigationController == nil")
                let viewController:UIViewController? = window?.rootViewController as? UIViewController
                guard let viewControllerCheck = viewController else {return}

                let ifreeCheck:Bool? = viewControllerCheck.isKind(of: ifreeWebViewController.self)
                if( !ifreeCheck! )
                {
                    let presentController = viewControllerCheck.presentedViewController
                  
                    let loginViewCheck:Bool? = presentController?.isKind(of: LoginViewController.self)
                    if loginViewCheck!
                    {
                        let vc = presentController?.presentedViewController

                        guard let ifreeWebViewController = vc as? ifreeWebViewController else { return  }
                        let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                        if strParsingDic != nil
                        {
                            ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                        }
                    }
                    else
                    {
                        let ifreeViewCheck:Bool? = presentController?.isKind(of: ifreeWebViewController.self)
                        if ifreeViewCheck!
                        {
                            guard let ifreeWebViewController = presentController as? ifreeWebViewController else { return  }
                            let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                            if strParsingDic != nil
                            {
                                ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                            }
                        }
                    }
                    
                }
                else
                {
                    guard let ifreeWebViewController = viewControllerCheck as? ifreeWebViewController else { return  }
                    let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                    if strParsingDic != nil
                    {
                        ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                    }
                    
                    
                }
            }
            else
            {
                let vcCheck = navigationController?.topViewController
                let ifreeCheck:Bool? = vcCheck?.isKind(of: ifreeWebViewController.self)
                if(vcCheck == nil || !ifreeCheck! )
                {

                    let presentController = navigationController?.presentedViewController

                    let loginViewCheck:Bool? = presentController?.isKind(of: LoginViewController.self)
                    if loginViewCheck!
                    {
                        let vc = presentController?.presentedViewController
   
                        guard let ifreeWebViewController = vc as? ifreeWebViewController else { return  }
                        let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                        if strParsingDic != nil
                        {
                            ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                        }
                    }
                    else
                    {
                        let ifreeViewCheck:Bool? = presentController?.isKind(of: ifreeWebViewController.self)
                        if ifreeViewCheck!
                        {
                            guard let ifreeWebViewController = presentController as? ifreeWebViewController else { return  }
                            let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                            if strParsingDic != nil
                            {
                                ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                            }
                        }
                    }
                    
                }
                else
                {
                    guard let ifreeWebViewController = vcCheck as? ifreeWebViewController else { return  }
                    let strParsingDic:NSDictionary? = ifreeManager.getInstance().ifreeResultParsing(url) as NSDictionary
                    if strParsingDic != nil
                    {
                        ifreeWebViewController.resultProcess(strParsingDic as! [AnyHashable : Any])
                    }

                }
                
            }
        }
        
      }
    
}

